package net.micode.notes.gtask.data;

import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.net.Uri;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.data.NotesDatabaseHelper.TABLE;
import net.micode.notes.gtask.exception.ActionFailureException;

import org.json.JSONException;
import org.json.JSONObject;


public class SqlData {
    private static final String TAG = SqlData.class.getSimpleName();
    //得到类的简写名称存入字符串TAG中，通过调用getSimpleName ()函数实现
    private static final int INVALID_ID = -99999;//将mDataId初始值置为-99999
    public static final String[] PROJECTION_DATA = new String[] {
            DataColumns.ID, DataColumns.MIME_TYPE, DataColumns.CONTENT, DataColumns.DATA1,
            DataColumns.DATA3
    };
    //以下五个变量作为sql表中5列的编号
    public static final int DATA_ID_COLUMN = 0;

    public static final int DATA_MIME_TYPE_COLUMN = 1;

    public static final int DATA_CONTENT_COLUMN = 2;

    public static final int DATA_CONTENT_DATA_1_COLUMN = 3;

    public static final int DATA_CONTENT_DATA_3_COLUMN = 4;
    //定义以下八个变量 
    //构造函数，用于初始化数据
    private ContentResolver mContentResolver;

    private boolean mIsCreate;

    private long mDataId;

    private String mDataMimeType;

    private String mDataContent;

    private long mDataContentData1;

    private String mDataContentData3;

    private ContentValues mDiffDataValues;

    public SqlData(Context context) { //判断是否直接用Content生成，是为true，否则为false
        mContentResolver = context.getContentResolver();//mContentResolver用于获取ContentProvider提供的数据
        mIsCreate = true;
        mDataId = INVALID_ID;
        mDataMimeType = DataConstants.NOTE;
        mDataContent = "";
        mDataContentData1 = 0;
        mDataContentData3 = "";
        mDiffDataValues = new ContentValues();
    }

    public SqlData(Context context, Cursor c) { //判断是否直接用Content生成，是为true，否则为false
        mContentResolver = context.getContentResolver();
        mIsCreate = false;
        loadFromCursor(c);
        mDiffDataValues = new ContentValues();
    }

    private void loadFromCursor(Cursor c) {
        // 从 Cursor 对象中获取列索引为 DATA_ID_COLUMN 的长整型数据，并将其赋值给当前对象的 mDataId 属性
        mDataId = c.getLong(DATA_ID_COLUMN);
        // 从 Cursor 对象中获取列索引为 DATA_MIME_TYPE_COLUMN 的字符串数据，并将其赋值给当前对象的 mDataMimeType 属性
        mDataMimeType = c.getString(DATA_MIME_TYPE_COLUMN);
        // 从 Cursor 对象中获取列索引为 DATA_CONTENT_COLUMN 的字符串数据，并将其赋值给当前对象的 mDataContent 属性
        mDataContent = c.getString(DATA_CONTENT_COLUMN);
        // 从 Cursor 对象中获取列索引为 DATA_CONTENT_DATA_1_COLUMN 的长整型数据，并将其赋值给当前对象的 mDataContentData1 属性
        mDataContentData1 = c.getLong(DATA_CONTENT_DATA_1_COLUMN);
        // 从 Cursor 对象中获取列索引为 DATA_CONTENT_DATA_3_COLUMN 的字符串数据，并将其赋值给当前对象的 mDataContentData3 属性
        mDataContentData3 = c.getString(DATA_CONTENT_DATA_3_COLUMN);
    }
    public void setContent(JSONObject js) throws JSONException {
        // 如果传入的JSONObject对象中有DataColumns.ID这一项，则设置，否则设为INVALID_ID
        long dataId = js.has(DataColumns.ID) ? js.getLong(DataColumns.ID) : INVALID_ID;
        // 如果当前是新增操作或数据ID已发生变化，将数据ID加入到待更新列表中
        if (mIsCreate || mDataId != dataId) { 
            mDiffDataValues.put(DataColumns.ID, dataId);
        }
        // 更新当前数据ID
        mDataId = dataId;

        // 获取数据的MIME类型，如果不存在则设置为DataConstants.NOTE
        String dataMimeType = js.has(DataColumns.MIME_TYPE) ? js.getString(DataColumns.MIME_TYPE)
                : DataConstants.NOTE;
        // 如果当前是新增操作或数据的MIME类型已发生变化，将MIME类型加入到待更新列表中
        if (mIsCreate || !mDataMimeType.equals(dataMimeType)) {
            mDiffDataValues.put(DataColumns.MIME_TYPE, dataMimeType);
        }
        // 更新当前数据的MIME类型
        mDataMimeType = dataMimeType;

        // 获取数据的内容，如果不存在则设置为空字符串
        String dataContent = js.has(DataColumns.CONTENT) ? js.getString(DataColumns.CONTENT) : "";
        // 如果当前是新增操作或数据的内容已发生变化，将数据内容加入到待更新列表中
        if (mIsCreate || !mDataContent.equals(dataContent)) {
            mDiffDataValues.put(DataColumns.CONTENT, dataContent);
        }
        // 更新当前数据的内容
        mDataContent = dataContent;

        // 获取数据的DATA1，如果不存在则设置为0
        long dataContentData1 = js.has(DataColumns.DATA1) ? js.getLong(DataColumns.DATA1) : 0;
        // 如果当前是新增操作或数据的DATA1已发生变化，将DATA1加入到待更新列表中
        if (mIsCreate || mDataContentData1 != dataContentData1) {
            mDiffDataValues.put(DataColumns.DATA1, dataContentData1);
        }
        // 更新当前数据的DATA1
        mDataContentData1 = dataContentData1;

        // 获取数据的DATA3，如果不存在则设置为空字符串
        String dataContentData3 = js.has(DataColumns.DATA3) ? js.getString(DataColumns.DATA3) : "";
        // 如果当前是新增操作或数据的DATA3已发生变化，将DATA3加入到待更新列表中
        if (mIsCreate || !mDataContentData3.equals(dataContentData3)) {
            mDiffDataValues.put(DataColumns.DATA3, dataContentData3);
        }
        // 更新当前数据的DATA3
        mDataContentData3 = dataContentData3;
    }


    public JSONObject getContent() throws JSONException {//创建JSONObject对象。并将相关数据放入其中，并返回
        if (mIsCreate) {
            Log.e(TAG, "it seems that we haven't created this in database yet");
            return null;
        }
        JSONObject js = new JSONObject();
        js.put(DataColumns.ID, mDataId);
        js.put(DataColumns.MIME_TYPE, mDataMimeType);
        js.put(DataColumns.CONTENT, mDataContent);
        js.put(DataColumns.DATA1, mDataContentData1);
        js.put(DataColumns.DATA3, mDataContentData3);
        return js;
    }

    public void commit(long noteId, boolean validateVersion, long version) {
        // 如果是新建数据，则需要把 noteId 设置进去，并插入到数据库中
        if (mIsCreate) {
            if (mDataId == INVALID_ID && mDiffDataValues.containsKey(DataColumns.ID)) {
                mDiffDataValues.remove(DataColumns.ID);
            }
            // 把 noteId 设置进去
            mDiffDataValues.put(DataColumns.NOTE_ID, noteId);
            // 插入到数据库中
            Uri uri = mContentResolver.insert(Notes.CONTENT_DATA_URI, mDiffDataValues);
            try {
                mDataId = Long.valueOf(uri.getPathSegments().get(1));
            } catch (NumberFormatException e) {
                Log.e(TAG, "Get note id error :" + e.toString());
                throw new ActionFailureException("create note failed");
            }
        } else { // 如果不是新建数据，则需要更新数据
            if (mDiffDataValues.size() > 0) {
                int result = 0;
                // 如果不需要验证版本号，则直接更新数据库
                if (!validateVersion) {
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues, null, null);
                } else { // 如果需要验证版本号，则需要在更新前进行检查
                    result = mContentResolver.update(ContentUris.withAppendedId(
                            Notes.CONTENT_DATA_URI, mDataId), mDiffDataValues,
                            " ? in (SELECT " + NoteColumns.ID + " FROM " + TABLE.NOTE
                                    + " WHERE " + NoteColumns.VERSION + "=?)", new String[] {
                                    String.valueOf(noteId), String.valueOf(version)
                            });
                }
                if (result == 0) {
                    Log.w(TAG, "there is no update. maybe user updates note when syncing");
                }
            }
        }
        // 清空修改数据的 Map，并标记为非新建数据
        mDiffDataValues.clear();
        mIsCreate = false;
    }

    public long getId() {//获取当前id
        return mDataId;
    }
}
